<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTemperatureMeasurement_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTemperatureMeasurement_V3 extends AbstractStructArrayBase
{
    /**
     * The TemperatureMeasurement_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TemperatureMeasurement_V3[]
     */
    public $TemperatureMeasurement_V3;
    /**
     * Constructor method for ArrayOfTemperatureMeasurement_V3
     * @uses ArrayOfTemperatureMeasurement_V3::setTemperatureMeasurement_V3()
     * @param \StructType\TemperatureMeasurement_V3[] $temperatureMeasurement_V3
     */
    public function __construct(array $temperatureMeasurement_V3 = array())
    {
        $this
            ->setTemperatureMeasurement_V3($temperatureMeasurement_V3);
    }
    /**
     * Get TemperatureMeasurement_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TemperatureMeasurement_V3[]|null
     */
    public function getTemperatureMeasurement_V3()
    {
        return isset($this->TemperatureMeasurement_V3) ? $this->TemperatureMeasurement_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTemperatureMeasurement_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTemperatureMeasurement_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTemperatureMeasurement_V3ForArrayConstraintsFromSetTemperatureMeasurement_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTemperatureMeasurement_V3TemperatureMeasurement_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfTemperatureMeasurement_V3TemperatureMeasurement_V3Item instanceof \StructType\TemperatureMeasurement_V3) {
                $invalidValues[] = is_object($arrayOfTemperatureMeasurement_V3TemperatureMeasurement_V3Item) ? get_class($arrayOfTemperatureMeasurement_V3TemperatureMeasurement_V3Item) : sprintf('%s(%s)', gettype($arrayOfTemperatureMeasurement_V3TemperatureMeasurement_V3Item), var_export($arrayOfTemperatureMeasurement_V3TemperatureMeasurement_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TemperatureMeasurement_V3 property can only contain items of type \StructType\TemperatureMeasurement_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TemperatureMeasurement_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TemperatureMeasurement_V3[] $temperatureMeasurement_V3
     * @return \ArrayType\ArrayOfTemperatureMeasurement_V3
     */
    public function setTemperatureMeasurement_V3(array $temperatureMeasurement_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($temperatureMeasurement_V3ArrayErrorMessage = self::validateTemperatureMeasurement_V3ForArrayConstraintsFromSetTemperatureMeasurement_V3($temperatureMeasurement_V3))) {
            throw new \InvalidArgumentException($temperatureMeasurement_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($temperatureMeasurement_V3) || (is_array($temperatureMeasurement_V3) && empty($temperatureMeasurement_V3))) {
            unset($this->TemperatureMeasurement_V3);
        } else {
            $this->TemperatureMeasurement_V3 = $temperatureMeasurement_V3;
        }
        return $this;
    }
    /**
     * Add item to TemperatureMeasurement_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\TemperatureMeasurement_V3 $item
     * @return \ArrayType\ArrayOfTemperatureMeasurement_V3
     */
    public function addToTemperatureMeasurement_V3(\StructType\TemperatureMeasurement_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TemperatureMeasurement_V3) {
            throw new \InvalidArgumentException(sprintf('The TemperatureMeasurement_V3 property can only contain items of type \StructType\TemperatureMeasurement_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TemperatureMeasurement_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TemperatureMeasurement_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TemperatureMeasurement_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TemperatureMeasurement_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TemperatureMeasurement_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TemperatureMeasurement_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TemperatureMeasurement_V3
     */
    public function getAttributeName()
    {
        return 'TemperatureMeasurement_V3';
    }
}
